{% extends "app/layout.html" %}

{% block content %}
    {% load staticfiles %}
    <script type="text/javascript">
        $("#admin_tab").addClass("active");
        var actor = JSON.parse("{{ actor | safe | escapejs }}")
        var role = actor['marketActorTypeid'].type;
    </script>
    <link rel="stylesheet" type="text/css" href="{% static 'app/content/bootstrap-table.min.css' %}" />
    <link rel="stylesheet" type="text/css" href="{% static 'app/content/bootstrap-datetimepicker.css' %}" />

    {% ifnotequal request.session.actor.marketActorTypeid.type "market operator" %}
        <h4>You are not authorized to view this page. This incident will be reported.</h4>

    {% else %}

        <div class="tabbable">
            <ul id="tabs" class="nav nav-tabs" data-tabs="tabs">
                <li role="presentation" class="active">
                    <a  id="users_tab" href="#users" data-toggle="tab" class="admin_tabs">
                        <h4><span class="fa fa-bookmark fa-lg"></span>Users</h4>
                    </a>
                </li>

                <li role="presentation">
                    <a id="sessions_tab" href="#sessions" data-toggle="tab" class="admin_tabs">
                        <h4><span class="fa fa-bar-chart-o fa-lg"></span>Sessions</h4>
                    </a>
                </li>

                <li role="presentation">
                    <a id="flexibility_tab" href="#flexibility" data-toggle="tab" class="admin_tabs">
                        <h4><span class="fa fa-bar-chart-o fa-lg"></span>Flexibility Parameters</h4>
                    </a>
                </li>

            </ul>
            <div id="my-tab-content" class="tab-content" >
                <div class="tab-pane active" id="users">
                    <div id="existing-mappings" style="display: none;">
                    <center>
                    <h3>Existing User-Actor mapping</h3>

                    <div id="custom-toolbar">
                        <span style="margin-right: 20px">
                            <i class="glyphicon glyphicon-ok text-success" style="vertical-align: initial"></i> <label>Validate participant</label>
                        </span>
                        <span>
                            <i class="glyphicon glyphicon-remove text-danger" style="vertical-align: initial"></i> <label>Cancel participant's validation</label>
                        </span>
                    </div>

                    <table
                        id="table"
                        data-classes="table table-hover "
                        data-search="true"
                        data-toolbar="#custom-toolbar"
                        data-show-toggle="false"
                        data-show-columns="true"
                        data-card-view="false"
                        data-click-to-select="false"
                        data-pagination="true"
                        data-page-list="[10, 25, 50, 100, ALL]"
                        data-sort-name="status"
                        data-sort-order="asc">
                        <thead>
                            <tr>
                                <th data-field="id" class="th th-inner" data-sortable="true" data-align="center" data-visible="false">Market Actor ID</th>
                                <th data-field="username" class="th th-inner" data-sortable="true" data-align="center" data-visible="false">Username</th>
                                <th data-field="representativeName" class="th th-inner" data-sortable="true" data-align="center" data-visible="true">Market Actor Name</th>
                                <th data-field="type" class="th th-inner" data-sortable="true" data-align="center" data-visible="true">Market Actor Type</th>
                                <th data-field="email" class="th th-inner" data-sortable="true" data-align="center" data-visible="true">Email</th>
                                <th data-field="phone" class="th th-inner" data-sortable="false" data-align="center" data-visible="true">Phone</th>
                                <th data-field="vat" class="th th-inner" data-sortable="false" data-align="center" data-visible="true">VAT</th>
                                <th data-field="market" class="th th-inner" data-sortable="false" data-align="center" data-visible="true">Market</th>
                                <th data-field="status" class="th th-inner" data-sortable="true" data-align="center" data-visible="true" data-formatter="setStatusFormatter">Status</th>
                                <th data-field="actions" class="th th-inner" data-sortable="false" data-align="center" data-visible="true" data-formatter="setActionsFormatter">Actions</th>
                            </tr>
                        </thead>
                    </table>
                    </center>
                    </div>

                        <div id="no-mappings" style="display: none;">
                    <center><h4>There are no username <=> Market Actor mappings.</h4></center>
                        </div>
                </div>

                <div class="tab-pane fade" id="sessions">

                    <div class="modal fade" id="addSession" tabindex="-1" role="dialog" aria-labelledby="addSessionLabel" aria-hidden="true">
                        <div class="modal-dialog">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                                    <h4 class="modal-title text-center" id="addSessionLabel">Generate new inactive market session</h4>
                                </div>
                                <form class="form-horizontal marginstopbot" id="AddSessionForm" onsubmit="return false;">
                                    <div class="form-group clearfix">
                                        <div class="col-sm-4 col-md-4 col-lg-4 col-xs-12">
                                            <label class="pull-right control-label" for="type"><strong>Type</strong><small class="text-danger">*</small></label>
                                        </div>
                                        <div class="col-md-8 col-sm-8 col-lg-8 col-xs-12" title="select one of the marketplace variants">
                                            <select class="form-control" name="type" id="type">
                                                <option value="-1" selected="selected" disabled="disabled">-- Select a marketplace variant --</option>
                                                <option value="energy">Energy</option>
                                                <option value="ancillary_services">Flexibility</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="form-group clearfix">
                                        <div class="col-sm-4 col-md-4 col-lg-4 col-xs-12">
                                            <label class="pull-right control-label" for="form"><strong>Form</strong><small class="text-danger">*</small></label>
                                        </div>
                                        <div class="col-md-8 col-sm-8 col-lg-8 col-xs-12" title="select a form">
                                            <select class="form-control" name="form" id="form">
                                                <option value="-1" selected="selected" disabled="disabled">-- Select a form --</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="form-group clearfix">
                                        <div class="col-sm-4 col-md-4 col-lg-4 col-xs-12">
                                            <label class="pull-right control-label" for="timeframe"><strong>Timeframe</strong><small class="text-danger">*</small></label>
                                        </div>
                                        <div class="col-md-8 col-sm-8 col-lg-8 col-xs-12" title="select a timeframe">
                                            <select class="form-control" name="timeframe" id="timeframe">
                                                <option value="-1" selected="selected" disabled="disabled">-- Select a timeframe --</option>
                                            </select>
                                        </div>
                                    </div>
{#                                     <div class="form-group clearfix">#}
{#                                        <div class="col-sm-4 col-md-4 col-lg-4 col-xs-12">#}
{#                                            <label class="pull-right control-label" for="type"><strong>Marketplace</strong><small class="text-danger">*</small></label>#}
{#                                        </div>#}
{#                                        <div class="col-md-8 col-sm-8 col-lg-8 col-xs-12" title="select one of the marketplace variants">#}
{#                                            <select class="form-control" name="mplace" id="mplace">#}
{#                                            </select>#}
{#                                        </div>#}
{#                                    </div>#}
<!--                                    <div class="form-group clearfix">-->
<!--                                        <div class="col-sm-4 col-md-4 col-lg-42 col-xs-12">-->
<!--                                            <label class="pull-right control-label" for="dso"><strong>Desired DSO</strong><small class="text-danger">*</small></label>-->
<!--                                        </div>-->
<!--                                        <div class="col-md-8 col-sm-8 col-lg-8 col-xs-12">-->
<!--                                            <select class="form-control" name="dso" id="dso">-->
<!--                                                <option value="0" disabled="disabled" selected="selected">&#45;&#45; Select DSO &#45;&#45;</option>-->
<!--                                                <option value="-1" class="hidden">All</option>-->
<!--                                            </select>-->
<!--                                        </div>-->
<!--                                    </div>-->
                                    <div class="form-group clearfix">
                                        <div class="col-sm-4 col-md-4 col-lg-4 col-xs-12">
                                            <label for="sessionStartTime" class="pull-right control-label"><strong>Session start time</strong><small class="text-danger">*</small></label>
                                        </div>
                                        <div class='col-md-8 col-sm-8 col-lg-8 date'>
                                            <input type='text' class="form-control" placeholder="session start time" id='sessionStartTime' />
                                        </div>
                                    </div>
                                    <div class="form-group clearfix">
                                        <div class="col-sm-4 col-md-4 col-lg-4 col-xs-12">
                                            <label for="sessionEndTime" class="pull-right control-label"><strong>Session end time</strong><small class="text-danger">*</small></label>
                                        </div>
                                        <div class="col-md-8 col-sm-8 col-lg-8 date">
                                            <input type='text' class="form-control" placeholder="session end time" id='sessionEndTime' />
                                        </div>
                                    </div>
                                    <div class="form-group clearfix">
                                        <div class="col-sm-4 col-md-4 col-lg-4 col-xs-12">
                                            <label for="deliveryStartTime" class="pull-right control-label"><strong>Delivery start time</strong><small class="text-danger">*</small></label>
                                        </div>
                                        <div class='col-md-8 col-sm-8 col-lg-8 date'>
                                            <input type='text' class="form-control" placeholder="delivery start time" id='deliveryStartTime' />
                                        </div>
                                    </div>
                                    <div class="form-group clearfix">
                                        <div class="col-sm-4 col-md-4 col-lg-4 col-xs-12">
                                            <label for="deliveryEndTime" class="pull-right control-label"><strong>Delivery end time</strong><small class="text-danger">*</small></label>
                                        </div>
                                        <div class="col-md-8 col-sm-8 col-lg-8 date">
                                            <input type='text' class="form-control" placeholder="delivery end time" id='deliveryEndTime' />
                                        </div>
                                    </div>
                                    <!--
                                    <div class="form-group clearfix">
                                        <div class="col-sm-4 col-md-4 col-lg-4 col-xs-12">
                                            <label for="clearingPrice" class="pull-right control-label"><strong>Clearing price</strong></label>
                                        </div>
                                        <div class="col-md-8 col-sm-8 col-lg-8 date">
                                            <input type='text' class="form-control" placeholder="clearing price (optional)" id='clearingPrice' />
                                        </div>
                                    </div>
                                    -->
                                    <div class="form-group">
                                        <div class="col-sm-4 col-md-4 col-lg-4 col-xs-12"></div>
                                        <div class="col-md-8 col-sm-8 col-lg-8 col-xs-12" style="font-size:14px">
                                            <label class="text-default"><span class="text-danger">*</span> Mandatory fields</label>
                                        </div>
                                    </div>

                                    <div class="form-group">
                                        <div class="col-sm-12 centre">
                                            <input id="resetSessionForm" type="reset" value="Reset" class="hidden">
                                            <button id="initSessionBtn" class="btn btn-accept btn-info btn-catalyst">Generate session</button>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>

                    <h3 style="text-align: center">Manage the market sessions</h3>
                    <div id="add_inactive_session">
                        <button class="btn btn-catalyst" onclick="newSession();">
                            <span class="glyphicon glyphicon-plus" style="vertical-align: initial!important"></span> Generate inactive session
                        </button>
                    </div>
                    <table
                        id="sessions_table"
                        class="table"
                        data-toolbar="#add_inactive_session"
                        data-pagination="true"
                        data-search="true"
                        data-page-list="[10, 25, 50, 100, 500]"
                        data-show-toggle="false"
                        data-show-columns="true"
                        data-card-view="false"
                        data-sort-name="sessionStartTime"
                        data-sort-order="desc"
                        data-click-to-select="false"
                        data-single-select="false"
                        data-show-export="true">
                        <thead>
                            <tr>
                                <th class="th th-inner" data-sortable="true"  data-align="center" data-field="id">#</th>
                                <th class="th th-inner" data-sortable="true" data-align="center" data-formatter="utcFormatter" data-field="sessionStartTime">Session start time</th>
                                <th class="th th-inner" data-sortable="false" data-align="center" data-formatter="utcFormatter" data-field="sessionEndTime">Session end time</th>
                                <th class="th th-inner" data-sortable="true" data-align="center"  data-formatter="utcFormatter" data-field="deliveryStartTime">Delivery start time</th>
                                <th class="th th-inner" data-sortable="false" data-align="center" data-formatter="utcFormatter" data-field="deliveryEndTime">Delivery end time</th>
                                <th class="th th-inner" data-sortable="true" data-align="center" data-formatter="marketplaceFormatter" data-field="marketplace">Marketplace</th>
                                <th class="th th-inner" data-sortable="true" data-align="center" data-formatter="SessionStatusFormatter" data-field="status">Session status</th>
                                <th class="th th-inner" data-sortable="true" data-align="center" data-formatter="formsFormatter" data-field="form">Form</th>
                            </tr>
                        </thead>
                    </table>
                </div>
                 <div class="tab-pane fade" id="flexibility">
                    <!-- SYSTEM PARAMETERS TABLE -->
                     <div id="table_data_helper">
                        <table
                        id="cor2"
                        data-toolbar="#toolbar_id"
                        data-toggle="table"
                        class="table"
                        data-side-pagination="client"
                        data-pagination="true"
                        data-search="true"
                        data-id-field="id"
                        data-page-list="[10, 25, 50, 100, ALL]"
                        data-sort-name="active"
                        data-sort-order="desc"
                        data-click-to-select="true"
                        data-single-select="true"
                        data-ajax-options="options">
                        <thead>
                        <tr>
                            <th class="th th-inner" data-sortable="true" data-field="id">ID</th>
                            <th class="th th-inner" data-sortable="true" data-field="name">Name</th>
                            <th class="th th-inner" data-sortable="true"  data-field="value">Value</th>
                            <th class="th th-inner" data-sortable="false" data-formatter="adminEditRulesFormatter" data-field="edit">Manage</th>
                        </tr>
                    </thead>
                    </table>
                    </div>

            <!-- edit settings modal-->
            <div class="modal fade" id="changeSettingsModal" tabindex="-1" role="dialog" aria-labelledby="addActionLabel" aria-hidden="true">
                <div class="modal-dialog" style="width:1000px; height: 500px;">
                    <div class="modal-content" style="height: 500px;">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span>
                            </button>
                            <h4 class="modal-title text-center" id="addActionLabel">Change settings</h4>
                        </div>
                        <form class="form-horizontal" id="AddActionForm" onsubmit="return false">
                        <div class="form-group">
                            <label for="reference_price" class="col-sm-4 control-label">Name</label>
                            <label  class="col-sm-4 control-label" id="name"></label>
                        </div>
                        <div class="form-group">
                            <label for="actionStartTime" class="col-sm-4 control-label"><strong>Current Value</strong>
                            </label>
                             <label for="reference_price" class="col-sm-4 control-label" id="curr_value"></label>
                        </div>
                        <div class="form-group">
                            <label for="actionEndTime" class="col-sm-4 control-label"><strong>New value</strong>
                            </label>
                            <input type="text" class="form-control col-sm-4 control-label" id="new_value" placeholder="New value" style="width: 140px">
                        </div>
                   <div class="form-group"></div>
                        <div class="form-group">
                            <label for="actionEndTime" class="col-sm-4 control-label"><strong></strong>
                            </label>
                             <button  class="btn btn-accept btn-info btn-catalyst" style="margin-left: 20%" onclick="updateSettings()">Save settings</button>
                        </div>

                        </form>
                    </div></div></div>
                    <div class="alert alert-success" id="succesDiv">
                      <strong>Success!</strong> Your settings have been updated!
                    </div>

                    <div class="alert alert-warning" id="warningDiv">
                      <strong>Warning!</strong> There was an error, please try again
                    </div>

                </div>
            </div>
        </div>
    {% endifnotequal %}
{% endblock %}

{% block scripts %}
    <script type="text/javascript">var token = "{{token}}";
    var forms = [];
    var DSOLIST_URL = "{{ DSO_LIST_URL }}";
    var FORM_URL = "{{FORMS}}";
    var ALLSESSION_URL = "{{ALLSESSION}}";
    var TIMEFRAME_LIST = "{{TIMEFRAME_LIST}}";
    var RULES_URL = "{{ RULES_URL }}";
    var SELECT_MPLACE = "{{ SELECT_MPLACE }}";
    var MPLACE_URL = "{{ MPLACE_URL }}";
    var SESSION_STATUS_URL = "{{ SESSION_STATUS_URL }}";
    var FORMS = "{{ FORMS }}";
    var memo_ip = "{{ memo}}";
    var user_markets = JSON.parse(JSON.parse("{{ user_markets | safe | escapejs }}"));


    </script>
    <script type="text/javascript" src="{% static 'app/scripts/bootstrap-table.min.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/bootstrap-table/extensions/export/bootstrap-table-export.min.js' %}" ></script>
    <script type="text/javascript" src="{% static 'app/scripts/bootstrap-table/extensions/export/tableExport.js' %}" ></script>
    <script type="text/javascript" src="{% static 'app/scripts/cookies.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/moment.min.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/moment-timezone-with-data-2010-2020.min.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/bootstrap-datetimepicker.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/moment-utc-formater.js' %}"></script>

    <script type="text/javascript" src="{% static 'app/scripts/session_table.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/utilities.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/admin/api.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/admin/session-validator.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/admin/main.js' %}"></script>
    <script type="text/javascript" src="{% static 'app/scripts/admin/flexibilityParameters.js' %}"></script>

    <script type="text/javascript">
        var token = "{{token}}";
        var tableSelector   = '#table';
        var gamRulesSelector= "#gam_rules";
        var relationURL ="{{RELATIONS}}";
        var USERNAME_TO_ACTOR = "{{ USERNAME_TO_ACTOR }}";
        var sessionStatuses = ['active', 'inactive', 'closed','cleared','completed','dummy'];
        var PENDING_REQUESTS = "{{ PENDING_REQUESTS }}";
        var USER_STATUS_URL = "{{ USER_STATUS }}";
        var selected_market = user_markets[0];

        $(document).ready(function(){
            moment.tz.setDefault("UTC");
            $("#existing-mappings").css('style', 'none');
            $("#no-mappings").css('style', 'none');


            var data = [];
            var pendingRequests;
            for (var i in user_markets){

                $.ajax({
                    url : user_markets[i].url + relationURL,
                    type : 'GET',
                    dataType : 'json',
                    async : false,
                    beforeSend: function (xhr) {
                        xhr.setRequestHeader("Authorization", token)
                    },
                    success : function(d) {
                        $("#existing-mappings").attr('style', '');
                        for (var r in d.relations){
                            var u_id = d.relations[r].user;
                            var a_id = d.relations[r].actor;
                            var st = d.relations[r].status;
                            var actor = d.actors.find(x => x.id === a_id)
                            var user = d.users.find(x => x.id === u_id)
                            data.push({
                                id: actor.id,
                                username: user.username,
                                representativeName: actor.representativeName,
                                email: actor.email,
                                phone: actor.phone,
                                type: actor.marketActorTypeid.type,
                                vat: actor.vat,
                                status: st,
                                market: user_markets[i].type.replace("_", " "),
                                market_url: user_markets[i].url,
                                token: user_markets[i].token,
                            });
                        }
                    },
                    error: function(e) {
                        console.log("error in getting all the users from the markets");
                    }
                });}
            data.sort((a,b) => (a.username > b.username) ? 1 : ((b.username > a.username) ? -1 : 0));
             $(tableSelector).bootstrapTable({data: data});
            var pending_found = false
            for (var i in user_markets) {
                if(pending_found)
                    break;
                $.ajax({
                    url: user_markets[i].url + PENDING_REQUESTS,
                    type: 'GET',
                    dataType: 'json',
                    beforeSend: function (xhr) {
                        xhr.setRequestHeader("Authorization", user_markets[i].token)
                    },
                    success: function (res) {
                        pendingRequests = res;
                        if (pendingRequests > 0) {
                            $("#mp-pending-requests").removeClass('hidden').html(pendingRequests);
                            pending_found = true;
                        } else {
                            $("#mp-pending-requests").addClass('hidden').html(0);
                        }
                    }
                });
            }


            $("#sessions_table").bootstrapTable({silent: true});
            $("#sessions_table").bootstrapTable('refresh');
            setInterval(function(){ $("#sessions_table").bootstrapTable('refresh', {silent: true}); }, 100000);

            $('#sessionStartTime').datetimepicker();
            $('#sessionStartTime').data("DateTimePicker").format(UtcDateTime.format());
            $('#sessionEndTime').datetimepicker();
            $('#sessionEndTime').data("DateTimePicker").format(UtcDateTime.format());
            $('#deliveryStartTime').datetimepicker();
            $('#deliveryStartTime').data("DateTimePicker").format(UtcDateTime.format());
            $('#deliveryEndTime').datetimepicker();
            $('#deliveryEndTime').data("DateTimePicker").format(UtcDateTime.format());

            $("#type").change(function(){ setSessionChoices($(this)); });
            {#$("#timeframe").change(function(){ setMarketplaceChoices(); });#}
            $("#initSessionBtn").click(function(){ submitSession(); });
        }).on('all.bs.table', tableSelector, function (name, args) {
            $("td").each(function () {
                $(this).css('vertical-align', 'middle');
            });

        }).on("click", ".validate-participant", function(e){
            e.preventDefault();
            url = $(this).data().url;
            token = $(this).data().token;
            data = {"username": $(this).data().username, "actor": $(this).data('actor-id'), "status":"valid"};
            $.ajax({
                  type: "PUT",
                  url: url + USER_STATUS_URL,
                  dataType: 'json',
                  contenttype:"application/json",
                  data: data,
                  beforeSend: function (xhr) {
                      xhr.setRequestHeader("Authorization", token)
                  },
                  success: function(){
                    $("#error_message").html("");
                    location.reload();
                  },
                  error: function(e) {
                    $("#error_message").html(e.responseText);
                  }
            });

        }).on("click", ".cancel-participant", function(e){
            e.preventDefault();

            url = $(this).data().url;
            token = $(this).data().token;
            data = {"username": $(this).data().username, "actor": $(this).data('actor-id'), "status":"invalid"};
            $.ajax({
                  type: "PUT",
                  url: url + USER_STATUS_URL,
                  dataType: 'json',
                  contenttype:"application/json",
                  data: data,
                  beforeSend: function (xhr) {
                      xhr.setRequestHeader("Authorization", token)

                  },
                  success: function(response){
                    location.reload();
                  },
                  error: function(e) {
                    $("#error_message").html(e.responseText);
                  }
            });
        }).on('all.bs.table', gamRulesSelector, function (name, args) {
            $("td").each(function () { $(this).css('vertical-align', 'middle').css('font-size', '11pt'); });
            $("th").css('vertical-align', 'middle');

        }).on('hide.bs.modal','#addSession', function () {
            resetSessionForm();
        }).on("click", ".marketplace", function(e){
            e.preventDefault();
            marketplaceInfo($(this).data('id'), $(this).data('registered-market-url'));
        });

    </script>

{% endblock %}

